-- Basic script for Akron bagger/extractor mod
-- put together by The Man With No Name
-- November 25, 2017
-- version 1.0

akronScript = {}

function akronScript.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations)
end

function akronScript:load(savegame)
    self.bagEndAnim = getXMLString(self.xmlFile, "vehicle.akron#bagEndAnimation")
    self.bagStartAnim = getXMLString(self.xmlFile, "vehicle.akron#bagStartAnimation")
    self.bagPalletAnim = getXMLString(self.xmlFile, "vehicle.akron#bagPalletAnimation")
end

function akronScript:delete()
end

function akronScript:readStream(streamId, connection)
end

function akronScript:writeStream(streamId, connection)
end

function akronScript:mouseEvent(posX, posY, isDown, isUp, button)
end

function akronScript:keyEvent(unicode, sym, modifier, isDown)
end

function akronScript:onAttach(attacherVehicle)
    if self.playAnimation ~= nil then
        if self.bagStartAnim ~= nil then
            self:playAnimation(self.bagStartAnim, -1, nil, true)
        end
        if self.bagPalletAnim ~= nil then
            self:playAnimation(self.bagPalletAnim, 1, nil, true)
        end
        if self.bagEndAnim ~= nil then
            self:playAnimation(self.bagEndAnim, 1, nil, true)
        end
    end
    if attacherVehicle ~= nil then
        if attacherVehicle.hasPipe then
            local nextState = attacherVehicle.pipeTargetState+1
            if nextState > attacherVehicle.pipeNumStates then
                nextState = attacherVehicle.pipeNumStates
            end
            if attacherVehicle:getIsPipeStateChangeAllowed(nextState) then
                attacherVehicle:setPipeState(nextState)
            elseif nextState ~= 1 and attacherVehicle:getIsPipeStateChangeAllowed(1) then
                attacherVehicle:setPipeState(1)
            end
        end
    end
end

function akronScript:onDetach()
    if self.playAnimation ~= nil then
        if self.bagStartAnim ~= nil then
            self:playAnimation(self.bagStartAnim, 1, nil, true)
        end
        if self.bagPalletAnim ~= nil and self:getFillLevel() <= 0 then
        self:playAnimation(self.bagPalletAnim, -1, nil, true)
        end
        if self.bagEndAnim ~= nil and self:getFillLevel() > 0 then
            self:playAnimation(self.bagEndAnim, -1, nil, true)
        end
    end
end

function akronScript:update(dt)
end

function akronScript:updateTick(dt)
end

function akronScript:draw()
end